# entrypoint

## Описание 

Это исполняемый файл, в котором прописаны команды для выполнения

!!! note
    Обязательный элемент системы. API доступно только внутри инфраструктуры серверной части lexema8. 

Пример 
```
#!/bin/bash
echo start app container ...
# get config
wait-for-it.sh config_service:3071 -t 60
if [ $? -eq 0 ]
then
  echo "Service available"
else
  echo "Service not available" 
  exit $?
fi
echo copy configs ...
rm /etc/nginx/sites-enabled/default
FILE=/etc/nginx/sites-enabled/default.conf
wget -c --output-document=$FILE http://config_service:3071/files/nginx/default.conf 
if [ ! -f "$FILE" ]; then
    echo "$FILE does not exist."
    exit 1
fi
echo test nginx config
nginx -t 
echo start app
# start
service nginx restart  && wait-for-it.sh redis:6379 && pmstart.sh && loop.sh
```

## Настройка entrypoint

В каталоге nginx находится файл default.conf
Этот файл загружается в сервис entrypoint при старте.

Файл содержит настройки маршрутов веб-сервисов.