# front

## Описание

Настройки клиентской части приложения.

- **_theme_** - имя пакета, содержащего тему оформления (по умолчанию - `'ecosoft-lexema8-main-theme'`).
- **_controls_** - перечень наборов контролов (по умолчанию - `'ecosoft-lexema8'`).
   - если элемент массива - строка, то она будет использована как путь для импорта конструктора контрола, относящемуся к данному набору. Манифест набора будет загружен по пути **{module_path}/lib/controls.manifest.json.**
   - если элемент массива - объект, то в качестве пути для импорта конструктора контрола будет использовано значение свойства modulePath, а в качестве пути для загрузки манифеста будет использовано значение свойства **manifestPath.**
- **_publicPath_** - настройка "публичного пути" для производственной сборки клиента (по умолчанию - `'/client/'`).
- **_sourcemap_** - флаг, обозначающий необходимость генерации карт кода (по умолчанию - `true`).
- **_es_** - настройки используемой версии ECMAScript (по умолчанию - `'legacy'`). Перекрывается опцией "ie" интерфейса командной строки.
   - **_legacy_** - с поддержкой IE11.
   - **_modern_** - без поддержки IE11.
- **_helpUrl_** - "базовая" ссылка для кнопки "Справка".
- **_autoLogin_** - если значение true, то клиент автоматически авторизуется под аккаунтом, который указан в сервисе gate (по умолчанию `false`).
- **_enableSSO_** - флаг, обозначающий доступность sso аутентификации на клиенте (автоматический вход на странице логина).
- **_adfsAuthType_** - Устанавливает тип авторизации через портал сервера федерации. Доступные значения: _saml, openid._ (по умолчанию отключено).
- **_pingOneAuthType_** - Устанавливает тип авторизации через портал PingOne. Доступные значения: _openid_. (по умолчанию отключено).
- **_disableMiddleNameValidation_** - позволяет отключить проверку заполнения отчества при создании нового пользователя и в личном кабинете (по умолчанию false).
- **_browserTabTitle_** - заголовок вкладки браузера (по умолчанию - `'lexema'`).
- **_disabledPersonalDataFields_** - массив, который содержит список аттрибутов пользователя, которые необходимо запретить для редактирования в личном кабинете (По умолчанию - `[]`). Доступные аттрибуты: _LastName_ - фамилия, _FirstName_ - имя, _MiddleName_ - отчество, _PhoneNumber_ - номер телефона.
- **_googleMaps_** - настройки контрола GoogleMaps (по умолчанию undefined).
  - **_key_** - ключ для работы с Google Maps API, способ получения описан в статье
  - **_version_** - версия Google Maps, рекомендуется ставить квартальное обновление "quarterly"
  - **_language_** - язык интерфейса. Для русского языка необходимо указать "ru". Поддерживаемые языки.
- **_region_** - регион использования. Для России необходимо указать "RU"
- **_allowRegistration_** - задает отображение кнопки регистрации на странице входа (используется для внешней регистрации пользователей).
- **_registration_** - настройки для внешней регистрации.
  - **_url_** - хост регистрационного сайта.
  - **_urlPath_** - дополнение к url с путем к форме заявки на регистрацию (по умолчанию пустая строка).
  - **_login_** - логин пользователя с доступом к форме заявки на регистрационном сайте.
  - **_password_** - пароль пользователя с доступом к форме заявки на регистрационном сайте.