# Post

## Описание

Сервис электронной почты и смс сообщений

!!! note
    Опциональный элемент системы. API доступно только внутри инфраструктуры серверной части lexema8. 
## Настройки сервиса электронной почты и смс сообщений.

- **protocol** - используемый веб-протокол (по умолчанию `http`).
- **host** - имя хоста (по умолчанию `localhost`).
- **port** - порт для запуска (по умолчанию - `3066`).
- **route** - используемый маршрут (по умолчанию `/api/v2.0/post`).
- **timeout** - количество миллисекунд бездействия, после которого считается, что время ожидания истекло (по умолчанию `120`). В режиме продакшена может потребоваться дополнительно настроить таймаут для веб-сервера (nginx).
- **script** - путь к модулю, запускающему сервис (по умолчанию `ecosoft-lexema8/post`).
- **attachmentRequestTimeout** - максимальное время ожидания загрузки файла в миллисекундах (по умолчанию `1000`).
- **defaultEmailId** - идентификатор почтового ящика, который используется по умолчанию.
- **emails** - словарь с описанием используемых почтовых ящиков. Ключом является уникальный идентификатор почтового ящика, а значением - объект со свойствами:
    - **host** - имя хоста smtp-сервера.
    - **port** - порт smtp-сервера.
    - **secure** - включить/выключить доставку по электронной почте с использованием TLS/STARTTLS (по умолчанию `false`). Доступные значения `true`, `false`. (Для `smtp.yandex.ru` значение должно быть `true`)
    - **rejectUnauthorized** - включает/выключает проверку сертификата. По умолчанию `true` (проверка включена).
    - **user** - логин.
    - **pass** - пароль.
    - **userName** - имя отображаемое при отправке почты. (Устаревшее свойство. Необязательное свойство)
    - **from** - адрес электронной почты отправителя для исходящих сообщений. Задается в формате: `<почта отправителя>` или `"Отображаемое имя отправителя" <почта отправителя>`. Если свойство `from` не задано, то формируется автоматически на основе заданных параметров `userName` и `user`.
- **sms** - настройки сервиса для отправки смс (можно не описывать, если код для восстановления пароля не отправляется через смс).
    - **provider** - имя провайдера, реализующий отправку смс сообщений (по умолчанию `undefined`). Доступные значения:
        - простор
        - mts
        - либо путь к своему собственному классу
    - **login** - логин.
    - **password** - пароль.
    - **sender** - имя отправителя.
- **flashCall** - настройки для сервисов Flash Call (авторизация по звонку).
    - **provider** - имя провайдера, реализующий отправку кода (по умолчанию `undefined`). Доступные значения: путь к своему собственному классу (наследник класса BaseFlashCall).
- **pushNotification** - настройки для интеграции с сервисом firebase для отправки push-уведомлений. Настройки необходимо получить в личном кабинете firebase. Перейдите в настройки вашего приложения (Project settings). В разделе Service accounts нажмите кнопку Generate new private key. Содержимое файла необходимо добавить в этот раздел.
