# Администрирование сервера БД

Администрирование сервера БД включает в себя два направления  - профилактические и экстренные работы.

Порядок состав и периодичность проведения профилактических работ приведены в табл. 1.

<table style="width:auto;">
  <thead>
    <tr>
      <th>ВИД РЕГЛАМЕНТА</th>
      <th>ДЛИТЕЛЬНОСТЬ, ЧАС</th>
      <th>ПЕРЕЧЕНЬ ОСНОВНЫХ ОПЕРАЦИЙ</th>
      <th>ИСПОЛНИТЕЛЬ</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td>Ежемесячный</td>
      <td style="text-align: center;">1</td>
      <td>Контроль целостности БД.<br>Обслуживание сервера БД.</td>
      <td>Администратор БД</td>
    </tr>
    <tr>
      <td>Ежемесячный</td>
      <td style="text-align: center;">1</td>
      <td>Исправление ОС.</td>
      <td>Автоматическая процедура, осуществляемая службой SMS Agent</td>
    </tr>
    <tr>
      <td>Ежемесячный</td>
      <td style="text-align: center;">1</td>
      <td>Анализ истории работы заданий по расписанию.<br>Отслеживание заданий с чрезмерной продолжительностью.</td>
      <td>Администратор БД</td>
    </tr>
    <tr>
      <td>Еженедельно</td>
      <td style="text-align: center;">0,5</td>
      <td>Контроль автоматического выполнения резервного копирования.</td>
      <td>Администратор БД</td>
    </tr>
    <tr>
      <td>По требованию</td>
      <td style="text-align: center;">0,5</td>
      <td>Установка обновлений.</td>
      <td>Администратор БД</td>
    </tr>
    <tr>
      <td>Ежедневный</td>
      <td style="text-align: center;">0,5</td>
      <td>Анализ системного журнала.</td>
      <td>Системный администратор</td>
    </tr>
    <tr>
      <td>Ежедневный</td>
      <td style="text-align: center;">0,5</td>
      <td>Анализ журнала регистрации событий безопасности.</td>
      <td>Администратор БД</td>
    </tr>
  </tbody>
</table>



Для обеспечения сохранности пользовательских данных и максимально быстрого восстановления системы в случае сбоев рекомендуется проводить следующие регламентные работы:

_1.	Мероприятия по обеспечению восстановления информационной системы после сбоев_

_1.1	План резервного копирования и восстановления ИС_

План резервного копирования.

* Должна быть организована система резервного копирования, обеспечивающая сохранность информации при аварии. 
* Резервное копирование базы данных, компонент системы должно выполняться ежедневно. Срок хранения резервной копии: 1 месяц

План резервного восстановления ИС включает в себя процедуру восстановления БД в рамках ИС. Восстановление работоспособности БД производится вручную штатными средствами СУБД PostgreSQL (pg_dump –U <superuser_name> –F c <database_name> > <dump_file_name>)

_1.2	Процедура резервного копирования_

Для автоматического резервного копирования базы данных необходимо как минимум 1 раз в неделю осуществляет полный бакап базы и 1 раз в день дифференциальный бакап, используя штатную утилиту PostgreSQL pg_dump.

_1.3	Процедура резервного восстановления_

Для восстановления базы данных PostgreSQL из файла архива, созданного с помощью команды pg_dump, используется команда pg_restore.

Для восстановления базы данных выполнить следующие действия:
* Восстановить полный бакап на каждом сервере
* Восстановить дифференциальный бакап на каждом сервер